//
// Created by robtor on 05.01.23.
//

#include "Menu_Entry_Type_Percent.h"

std::string floatpump::menu::Menu_Entry_Type_Percent::toString() {
    if (m_entered) {
        return fmt::format("> {:3} %", *m_value);
    } else {
        return fmt::format("  {:3} %", *m_value);
    }
}

void floatpump::menu::Menu_Entry_Type_Percent::u_press() {
    m_entered = !m_entered;
}

void floatpump::menu::Menu_Entry_Type_Percent::u_increase(uint16_t steps) {
    if (*m_value < 100)
        (*m_value)++;
}

void floatpump::menu::Menu_Entry_Type_Percent::u_decrease(uint16_t steps) {
    if (*m_value > 0) {
        (*m_value)--;
    }
}

bool floatpump::menu::Menu_Entry_Type_Percent::isEntered() {
    return m_entered;
}

floatpump::menu::Menu_Entry_Type_Percent::Menu_Entry_Type_Percent(uint8_t val) {
    m_value = new uint8_t(val);
}

void floatpump::menu::Menu_Entry_Type_Percent::linkConfig(uint8_t *link) {
    m_value = link;
}
